=== debian/changelog ===
lambda-align2 (2.0.0-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:17:43 +0100

lambda-align2 (2.0.0-2) unstable; urgency=medium

  * Enable verbose mode in d/rules.
  * Only activate multiopt builds on archs that support the required
    compiler flags.

 -- Sascha Steinbiss <satta@debian.org>  Sat, 19 Jan 2019 23:19:18 +0100

lambda-align2 (2.0.0-1) unstable; urgency=medium

  * Initial packaging for 2.x series (Closes: #919726)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 14 Jan 2019 02:03:34 -0800
