=== debian/control ===
Source: lambda-align2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>,
           Sascha Steinbiss <satta@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 12~),
               libseqan2-dev,
               cmake,
               zlib1g-dev,
               libbz2-dev,
               openssl
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/med-team/lambda-align2
Vcs-Git: https://salsa.debian.org/med-team/lambda-align2.git
Homepage: https://seqan.github.io/lambda

Package: lambda-align2
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Local Aligner for Massive Biological DatA - v2
 Lambda2 is a local biosequence aligner optimized for many query sequences
 and searches in protein space. It is compatible to the de facto standard tool
 BLAST, but often outperforms the best currently available alternatives at
 reproducing BLAST’s results and is the fastest compared with the current
 state of the art at comparable levels of sensitivity.
 .
 This package is for the Lambda (align) v2.x series which has an incompatible
 command line interface and on disk format from Lambda (align) v1.x.
