=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk

MULTIOPT_ARCHS = amd64 kfreebsd-amd64

ifneq (,$(findstring $(DEB_HOST_ARCH),$(MULTIOPT_ARCHS)))
	ENABLE_MULTIOPT="-DLAMBDA_MULTIOPT_BUILD=1"
else
	ENABLE_MULTIOPT="-DLAMBDA_MULTIOPT_BUILD=0"
endif

%:
	dh $@ --builddirectory=build

override_dh_install:
	dh_install
	find debian -name "LICENSE*.rst" -delete

override_dh_auto_configure:
	dh_auto_configure -- \
		-DLAMBDA_NATIVE_BUILD=OFF \
		-DLAMBDA_MMAPPED_DB=OFF \
		-DCMAKE_BUILD_TYPE=Release \
		$(ENABLE_MULTIOPT) \
		-DLAMBDA_COMPILE_THREADS=$(shell nproc)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	#for md5 in debian/*.md5sums; do gzip --keep $${md5}; done
	#cp --backup debian/*md5sums.gz tests/
	#cd build/tests && ctest . -j$(shell nproc) -I 1,10
endif

override_dh_auto_clean:
	if ls tests/*~ 1> /dev/null 2>&1; then \
	  for backup in tests/*~; do mv $${backup} $${backup%\~}; done; \
	fi
	dh_auto_clean

override_dh_dwz:
	# pass
