=== debian/changelog ===
lambda-align2 (2.0.1-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1113093)

 -- Adrian Bunk <bunk@debian.org>  Sat, 11 Oct 2025 21:29:07 +0300

lambda-align2 (2.0.1-3) unstable; urgency=medium

  * Team upload.
  * Added patch to enable install on non-amd64 archs
  * d/control: build on any arch
  * d/control: openssl is only needed for tests

 -- Enrico Seiler <enrico.seiler.debian@outlook.com>  Thu, 28 Nov 2024 13:53:13 +0100

lambda-align2 (2.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Drop patches applied upstream.
  * Bump d/copyright date.
  * Bump Standards-Version.

 -- Sascha Steinbiss <satta@debian.org>  Fri, 21 Jul 2023 11:37:14 +0200

lambda-align2 (2.0.0-9) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS with glibc 2.32 (thanks for the patch to Gianfranco Costamagna)
    Closes: #976691

 -- Andreas Tille <tille@debian.org>  Mon, 07 Dec 2020 16:04:42 +0100

lambda-align2 (2.0.0-8) unstable; urgency=medium

  * Team upload.
  * Do not set LAMBDA_COMPILE_THREADS explicitly but trust --parallel default
    dh option
    Closes: #975706
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 04 Dec 2020 15:59:33 +0100

lambda-align2 (2.0.0-7) unstable; urgency=medium

  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 12 (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Only build on amd64 for now. (Closes: #953081)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * debian/upstream/metadata: add Repository and Repository-Browse

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sun, 29 Mar 2020 12:32:34 +0200

lambda-align2 (2.0.0-6) unstable; urgency=medium

  * Adjust reproducibility patch.
    Closes: #920591

 -- Sascha Steinbiss <satta@debian.org>  Sat, 08 Jun 2019 14:49:26 +0200

lambda-align2 (2.0.0-5) unstable; urgency=medium

  * Team upload.
  * make the build reproducible (thanks for the patch to
    Chris Lamb <lamby@debian.org>)
    Closes: #920591

 -- Andreas Tille <tille@debian.org>  Sun, 27 Jan 2019 11:18:13 +0100

lambda-align2 (2.0.0-4) unstable; urgency=medium

  * Skip checking md5sums in the tests as they are not currently stable.
  * Post process the unix manual pages to remove errors with regards to the
    subcommands.

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 23 Jan 2019 11:54:46 -0800

lambda-align2 (2.0.0-3) unstable; urgency=medium

  * Fix 32-bit builds. Thanks to Michael R. Crusoe for the patch.

 -- Sascha Steinbiss <satta@debian.org>  Tue, 22 Jan 2019 13:42:56 +0100
