=== debian/control ===
--- 
+++ 
@@ -1,19 +1,20 @@
 Source: lambda-align2
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>,
+Uploaders: Michael R. Crusoe <crusoe@debian.org>,
            Sascha Steinbiss <satta@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 12~),
+Build-Depends: debhelper-compat (= 13),
                libseqan2-dev,
                cmake,
                zlib1g-dev,
                libbz2-dev,
-               openssl
-Standards-Version: 4.3.0
+               openssl <!nocheck>
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/lambda-align2
 Vcs-Git: https://salsa.debian.org/med-team/lambda-align2.git
 Homepage: https://seqan.github.io/lambda
+Rules-Requires-Root: no
 
 Package: lambda-align2
 Architecture: any
