=== debian/rules ===
--- 
+++ 
@@ -17,6 +17,19 @@
 %:
 	dh $@ --builddirectory=build
 
+override_dh_installman:
+	sed -i -e 's@\(defaults to working directory\.\).*@\1@g' ./debian/lambda-align2/usr/share/man/man1/*.1
+	sed -i -e 's@\(number of threads to run concurrently\).*@\1. Default: autodetected.@g' ./debian/lambda-align2/usr/share/man/man1/*.1
+	sed -i 's/LAMBDA2 MKINDEXN/LAMBDA2_MKINDEXN/' ./debian/lambda-align2/usr/share/man/man1/lambda2-mkindexn.1
+	sed -i 's/^lambda2 mkindexn /lambda2_mkindexn /' ./debian/lambda-align2/usr/share/man/man1/lambda2-mkindexn.1
+	sed -i 's/LAMBDA2 MKINDEXP/LAMBDA2_MKINDEXP/' ./debian/lambda-align2/usr/share/man/man1/lambda2-mkindexp.1
+	sed -i 's/^lambda2 mkindexp /lambda2_mkindexp /' ./debian/lambda-align2/usr/share/man/man1/lambda2-mkindexp.1
+	sed -i 's/LAMBDA2 SEARCHN/LAMBDA2_SEARCHN/' ./debian/lambda-align2/usr/share/man/man1/lambda2-searchn.1
+	sed -i 's/^lambda2 searchn /lambda2_searchn /' ./debian/lambda-align2/usr/share/man/man1/lambda2-searchn.1
+	sed -i 's/LAMBDA2 SEARCHP/LAMBDA2_SEARCHP/' ./debian/lambda-align2/usr/share/man/man1/lambda2-searchp.1
+	sed -i 's/^lambda2 searchp /lambda2_searchp /' ./debian/lambda-align2/usr/share/man/man1/lambda2-searchp.1
+	dh_installman
+
 override_dh_install:
 	dh_install
 	find debian -name "LICENSE*.rst" -delete
@@ -26,14 +39,13 @@
 		-DLAMBDA_NATIVE_BUILD=OFF \
 		-DLAMBDA_MMAPPED_DB=OFF \
 		-DCMAKE_BUILD_TYPE=Release \
-		$(ENABLE_MULTIOPT) \
-		-DLAMBDA_COMPILE_THREADS=$(shell nproc)
+		$(ENABLE_MULTIOPT)
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	#for md5 in debian/*.md5sums; do gzip --keep $${md5}; done
 	#cp --backup debian/*md5sums.gz tests/
-	#cd build/tests && ctest . -j$(shell nproc) -I 1,10
+	#cd build/tests && ctest .  -I 1,10
 endif
 
 override_dh_auto_clean:
