=== debian/tests/control ===
Tests: run-tests
Depends: @, @builddeps@, openssl, gzip, coreutils, diffutils, ncbi-blast+
Restrictions: allow-stderr
