=== debian/watch ===
version=4
https://github.com/seqan/lambda/tags .*/lambda-v(2\.\d+\.\d+)\.tar.gz
